// oct.v.glsl
//

#version 330 core

layout (location = 0) in vec3 v_position;
layout (location = 1) in vec3 v_normal;
layout (location = 2) in vec3 v_offset;

uniform mat4 rot_by;

uniform mat4 mvp;
uniform vec3 to_light;  // Expected to be a unit vector.
uniform vec3 base_color;
uniform vec3 translate_by;
uniform int use_v_offset;

flat out vec3 color;

void main() {
//  v_position = vec3(rotate_by * vec4(v_position, 1.0));

  vec3 off = translate_by;
  if (use_v_offset > 0) off += v_offset;

  gl_Position = mvp * vec4(vec3(rot_by * vec4(v_position, 1.0)) + off, 1.0);
  //gl_Position = mvp * vec4(v_position + v_offset + translate_by, 1.0);
  
  //float diffuse = clamp(dot(to_light, v_normal), 0.15, 1.0);
  vec3 rot_normal = vec3(rot_by * vec4(v_normal, 1.0));
  float diffuse = dot(to_light, rot_normal) * 0.4 + 0.6;
  
  // This is a way to brighten things a bit that is cheaper (I think) than a sqrt.
  //diffuse = 2 * diffuse / (1 + diffuse);
  
  color = base_color * diffuse;
}

