// sky.f.glsl
//

#version 330 core

in vec3  world_position;

out vec3 out_color;

uniform vec3 player_pos;
uniform vec3 sun_dir;

uniform int reverse_colors;

float rand(vec3 co){
  return fract(sin(dot(co ,vec3(12.9898,78.233, -12.12381))) * .5453);
}

void main() {
  
  vec3 dir = normalize(world_position - player_pos);
  
  //float n = rand(dir);
  
  float daytime = smoothstep(-0.7, -0.2, sun_dir.y);
  
  vec3 blue  = vec3(0.0, 0.0, 1.0) * daytime;
  vec3 yellow = vec3(0.5, 0.5, 1.0);

  
  float sun  = dot(dir, sun_dir);
  float sunc = clamp(sun, 0.0, 1.0);
  
  float glow = smoothstep(0.99, 1.0, sunc);
  
  out_color = mix(blue, yellow, glow);
  
  float sun_center = smoothstep(0.995, 1.0, sunc);
  
  vec3 white = vec3(1.0, 1.0, 1.0);
  
  out_color = mix(out_color, white, sun_center);
  
  vec3 fog_white = vec3(1.0, 1.0, 1.0) * clamp(daytime, 0.5, 1.0);
  
  out_color = clamp(out_color + smoothstep(0.5, -1.0, dir.y) * fog_white, 0, 1);
  
  if (reverse_colors != 0) {
    
    out_color = vec3(1.0, 1.0, 1.0) - out_color;
    
  }
  
}

